#!/bin/env python
#------------------------------------------------------------------------------
# 20000803 V0.1   JH	First version to hit the net.
# 20000804 V0.1.1 JH	The check for the parametercount was added in the last
#						minute, and I forgot to test it :(

import pickle
import os
import pprint
import sys
from string import rstrip
from string import split
from string import lower
import socket

#------------------------------------------------------------------------------

hostcache = {}
def gethostname( ipaddr ):
	try:
		return hostcache[ipaddr]
	except KeyError:
		if ipaddr == "":
			hostcache[ipaddr] = "unknown"
		else:
			try:
				host = socket.gethostbyaddr( ipaddr )[0]
				if host != '':
					hostcache[ipaddr] = socket.gethostbyaddr( ipaddr )[0]
				else:
					hostcache[ipaddr] = ipaddr
			except:
				hostcache[ipaddr] = ipaddr

	return hostcache[ipaddr]

#	if not hostcache.has_key( ipaddr ):
#		hostname = socket.gethostbyaddr( ipaddr )
#		if hostname and hostname[0]:
#			hostcache[ipaddr] = hostname[0]
#		else:
#			hostcache[ipaddr] = ipaddr
#	return hostcache[ipaddr]

#------------------------------------------------------------------------------

accesslog = []

lastdate = "00/Jan/0000:00:00:00"

monthname = {
	"Jan": 0, "Feb": 1, "Mar": 2, "Apr": 3, "May": 4, "Jun": 5,
	"Jul": 6, "Aug": 7,	"Sep": 8, "Oct": 9, "Nov": 10, "Dec": 11
}

def comparedate( d1, d2 ):
	#12/Apr/2000:17:10:49 +0000
	if d1[7:11] < d2[7:11]:		return -1
	elif d1[7:11] > d2[7:11]:	return 1
	if monthname[d1[3:6]] < monthname[d2[3:6]]: return -1
	elif monthname[d1[3:6]] > monthname[d2[3:6]]: return 1
	if d1[0:2] < d2[0:2]:		return -1
	elif d1[0:2] > d2[0:2]:		return 1
	if d1[12:14] < d2[12:14]:		return -1
	elif d1[12:14] > d2[12:14]:		return 1
	if d1[15:17] < d2[15:17]:		return -1
	elif d1[15:17] > d2[15:17]:		return 1
	if d1[18:20] < d2[18:20]:		return -1
	elif d1[18:20] > d2[18:20]:		return 1
	return 0
	
#print comparedate( '12/Apr/2000:11:10:49', '12/Apr/2000:12:10:49' )
#                    01234567890123456789
#sys.exit( 1 )

def printlogent( ent ):
	global lastdate
	if ent.has_key('host') and ent.has_key('date') and ent.has_key('req'):
		date = ent['date']
		date = '%s/%s/%s:%s' % (date[0:2],date[3:6],date[7:11],date[12:])
		if comparedate( date, lastdate ) < 0:
#			print '*******************FIXING DATE(%s -> %s)**********************'%(date,lastdate)
			date = lastdate
		else:
			lastdate = date
		log = '%s - - [%s] "%s" %s %s "%s" "%s"' % (ent['host'], date, ent['req'], ent.get('status',200), ent.get('length','-'),  ent.get('referer','-'), ent.get('agent','-') )
#		accesslog.append( (date,log) )
		print log
	else:
		sys.stderr.write( 'invalid connection, dropping:\n%s\n'%(pp.pformat(connections[id])) )

#------------------------------------------------------------------------------

if len(sys.argv) != 3:
	print 'Usage: %s <rhlog> <leftovers>'%sys.argv[0]
	print '        rhlog:     RobinHood log to convert'
	print '        leftovers: file that contains the \'leftovers\' between runs'
	sys.exit( 1 )

#sys.stdout = sys.stderr

pp = pprint.PrettyPrinter( indent=4 );

sys.stderr.write( 'Reading '+sys.argv[1]+'...\n' )

rhlogfile = open( sys.argv[1], 'rt' )
rhlogfile.seek( 0, 2 )
rhlogfile_len = rhlogfile.tell()
rhlogfile.seek( 0, 0 )
rhlogfile_lineno = 0

# Read old unresolved connections
sys.stderr.write( 'Reading old unresolved connections'+sys.argv[2]+'...\n' )
try:
	file = open( sys.argv[2], 'r' )
	lastdate = pickle.load( file )
	connections = pickle.load( file )
except:
	connections = {}

while 1:
	line = rhlogfile.readline()
	if not line:
		break
	rhlogfile_lineno = rhlogfile_lineno + 1
		
	if line[0] == '#':
		continue

	if (rhlogfile_lineno%1000) == 0:
		sys.stderr.write( '\rReading %s [%dK/%dK]...' % (sys.argv[1],rhlogfile.tell()/1024,rhlogfile_len/1024) )
		sys.stderr.flush()

	line = rstrip( line )
	splitline = split( line, ' ', 2 )

	if len(splitline) != 3:
		sys.stderr.write( 'INVALID LINE: "' + line + '"\n' )
		continue
		
#	sys.stdout.write( '\t\t' + line + '\n' )

	try:
		id = int(splitline[0])
	except:
		sys.stderr.write( 'INVALID LINE: "' + line + '"\n' )
		continue

	if splitline[1] == 'Open:':
		if connections.has_key( id ):
			connection = connections[id]
			if connection.has_key( 'req' ):
				sys.stderr.write( '\rline %d, connection %d: unclosed connection, forcing:\n%s\n'%(rhlogfile_lineno,id,pp.pformat(connections[id])) )
				printlogent( connection )
		connection = {}
		connections[id] = connection
		opensplit = split( splitline[2], ' ', 1 )
		connection['host'] = gethostname( opensplit[0] )
		connection['date'] = opensplit[1][5:] + ' +0000'
		connection['line'] = rhlogfile_lineno

	else:
		if not connections.has_key( id ):
			sys.stderr.write( '\rline %d, connection %d: connection was never opened, dropping:\n    %s\n'%(rhlogfile_lineno,id,line) )
		else:
			connection = connections[id]

			if splitline[1] == 'Header:':
				headersplit = split( splitline[2], ' ', 1 )
				headersplit[0] = lower( headersplit[0] )
				if headersplit[0] == 'user-agent:':
					connection['agent'] = headersplit[1]
				elif headersplit[0] == 'referer:':
					connection['referer'] = headersplit[1]

			elif splitline[1] == 'Request-Line:':
				if connection.has_key( 'req' ):
					sys.stderr.write( '\rline %d, connection %d: new request, forcing:\n%s\n'%(rhlogfile_lineno,id,pp.pformat(connection)) )
					printlogent( connection )
					del connection['req']
				connection['req'] = splitline[2]

			elif splitline[1] == 'Status-Line:':
				statussplit = split( splitline[2], ' ', 2 )
				connection['status'] = statussplit[1]

			elif splitline[1] == 'Sending:':
				sendingsplit = split( splitline[2], ' ' )
				connection['length'] = sendingsplit[0]

			elif splitline[1] == 'Sent:':
				sentsplit = split( splitline[2], ' ' )
				connection['length'] = sentsplit[0]
				printlogent( connection )
				del connection['req']
#				del connections[id]

			elif splitline[1] == 'Close:':
				if connection.has_key( 'req' ):
					sys.stderr.write( '\rline %d, connection %d: unclosed connection, forcing:\n%s\n'%(rhlogfile_lineno,id,pp.pformat(connection)) )
					printlogent( connection )
				del connections[id]

sys.stderr.write( '\n' )
sys.stderr.write( 'unclosed connections, saving:\n%s\n'%(pp.pformat(connections)) )

# Write unresolved connections
file = open( sys.argv[2], 'w' )
pickle.dump( lastdate, file )
pickle.dump( connections, file )

# This is properly not nessary any longer...
sys.stderr.write( 'Sorting...\n' )
accesslog.sort()

sys.stderr.write( '\n' )
sys.stderr.write( 'Writing common log...\n' )
for hit in accesslog:
	print hit[1]

#------------------------------------------------------------------------------
